#!/usr/bin/perl -w

use strict;

use lib '__modules_path__';
use Net::FTP;
use Foundation;

# ftp magic

my $ftp = Net::FTP->new( "ftp.tidbits.com", Debug => 0 )
	or die "Cannot connect to host: $@";

$ftp->login( "anonymous", '-anonymous@' )
	or die "Cannot login ", $ftp->message;

my @listing_1 = $ftp->dir( "__ftp_path_1__" );
my @listing_2 = $ftp->dir( "__ftp_path_2__" );

my $count;
$count = @listing_1;
my $cocoa_array_listing_1 = NSMutableArray->arrayWithCapacity_( $count );
$count = @listing_2;
my $cocoa_array_listing_2 = NSMutableArray->arrayWithCapacity_( $count );

my $line = "empty";

foreach $line ( @listing_1 )
	{
	$cocoa_array_listing_1->addObject_( NSString->stringWithCString_( $line ) );
	}

foreach $line ( @listing_2 )
	{
	$cocoa_array_listing_2->addObject_( NSString->stringWithCString_( $line ) );
	}

$ftp->quit;

# ftp magic ends

# setup the cocoa dictionary

my $cocoa_dictionary = NSMutableDictionary->dictionaryWithCapacity_( 2 );

# paths array, where issues are found
# these paths will act as keys for the arrays holding the actual file names

my $cocoa_array_directories = NSMutableArray->arrayWithCapacity_( 2 );

$cocoa_array_directories->addObject_( NSString->stringWithCString_( "__ftp_path_1__" ) );

$cocoa_array_directories->addObject_( NSString->stringWithCString_( "__ftp_path_2__" ) );

$cocoa_dictionary->setObject_forKey_( $cocoa_array_directories,
	NSString->stringWithCString_( "Paths Array" ) );

# title arrays, the dictionary key will be the path from the above array
# these arrays will hold the contents for the above paths

$cocoa_dictionary->setObject_forKey_( $cocoa_array_listing_1,
	NSString->stringWithCString_( "__ftp_path_1__" ) );

$cocoa_dictionary->setObject_forKey_( $cocoa_array_listing_2,
	NSString->stringWithCString_( "__ftp_path_2__" ) );

# setup the path and write out the dictionary

my $output_file_path = "~/Library/Application Support/XBit/ftp_listing.plist";

my $cocoa_path = NSString->stringWithCString_( $output_file_path );
$cocoa_path = $cocoa_path->stringByExpandingTildeInPath();

$cocoa_dictionary->writeToFile_atomically_( $cocoa_path, 1 );
